﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using projectDoubleDeckerBus.Drawings;
using projectDouble_Decker_Bus.MovementStrategy;
using projectDoubleDeckerBus.Generics;

namespace projectDoubleDeckerBus
{
    public partial class FormBusCollection : Form
    {
        private readonly BusesGenericCollection<DrawningBus,
        DrawningObjectBus> _buses;
        public FormBusCollection()
        {
            InitializeComponent();
            _buses = new BusesGenericCollection<DrawningBus,
            DrawningObjectBus>(DrawBus.Width, DrawBus.Height);
        }

        private void buttonAddBus_Click(object sender, EventArgs e)
        {
            FormDoubleDeckerBus form = new();
            if (form.ShowDialog() == DialogResult.OK)
            {
                if (_buses + form.SelectedBus != -1)
                {
                    MessageBox.Show("Объект добавлен");
                    DrawBus.Image = _buses.ShowCars();
                }
                else
                {
                    MessageBox.Show("Не удалось добавить объект");
                }
            }
        }

        private void buttonDeleteBus_Click(object sender, EventArgs e)
        {
            if (MessageBox.Show("Удалить объект?", "Удаление",
            MessageBoxButtons.YesNo, MessageBoxIcon.Question) == DialogResult.No)
            {
                return;
            }
            int pos = Convert.ToInt32(InputtextBox.Text);
            if (_buses - pos != null)
            {
                MessageBox.Show("Объект удален");
                DrawBus.Image = _buses.ShowCars();
            }
            else
            {
                MessageBox.Show("Не удалось удалить объект");
            }
        }

        private void buttonUpdateCollection_Click(object sender, EventArgs e)
        {
            DrawBus.Image = _buses.ShowCars();
        }
    }
}
